#!/bin/sh
echo "ZipitZ2 OpenWrt RecoveryOs to OpenWrt Gmenu2x flasher script v0.03"
# Copyright (C) 2010 Marek Vasut <marek.vasut@gmail.com>
# This is under GPL v3
# Modified by rkdavis  http://russelldavis.org
# Modified by mozzwald http://www.mozzwald.com

# filenames
image=image.img
partlist=plist.lst
flashdefs=flash.def

# check md5sum
md5=`cat image.md5`
echo -n "Calculating md5..."
if [ "$md5" != "`md5sum $image | cut -d " " -f 1`" ] ; then
	echo "md5sum mismatch on image.img! Try downloading again."
	echo "Exiting..."
	exit 1
else
	echo "OK"
fi

echo -n "Fixing mtdblocks..."
rm /dev/mtdblock1
mknod /dev/mtdblock1 b 31 1
rm /dev/mtdblock2
mknod /dev/mtdblock2 b 31 2
rm /dev/mtdblock3
mknod /dev/mtdblock3 b 31 3
rm /dev/mtdblock4
mknod /dev/mtdblock4 b 31 4
echo "OK"

echo "Last chance before flashing. Are you sure (yes/no)"
read flash

if [ "$flash" != "yes" ]; then
	echo "You didn't enter yes so aborting"
	exit 1
fi

offset=262144
while read part size ; do
	echo "Writing to $part"
	dd if="$image" of="$part" bs=1 skip="$offset" count="$size"
	offset=`expr "$offset" + "$size"`;
done < "$partlist"

echo "Finished! Press ENTER to power down"
read enter
echo "Powering down in 5 seconds... (CTRL-C to Cancel)"
sleep 5
poweroff
